#include "Quaternion.h"
#include <iostream>
#include <stdio.h>

using namespace std;


#define W 0.022

#define INDEX(i,j,k) ( (i)+(tx)*(j)+(tx)*(ty)*(k) )

void calcFractal(float *dens, int tx, int ty, int tz, double cst=0.00){
	//const double cst=0.00;

	Quaternion c;
	//Quaternion c(0.20, 0.6, 0.25, -0.46);

	Quaternion q;
	Quaternion tmp;

	double dx=2.00, dy=2.00, dz=2.00;
	double px=-1.00, py=-1.00, pz=-1.00;

	double mX=dx/(double)tx;
	double mY=dy/(double)ty;
	double mZ=dz/(double)tz;

	double norm=0.0;

	int cpt=0;

	
		//c.x=-0.3; c.y=0.3; c.z=0.4; c.w= 0.0;

	///	c.x=-0.5; c.y=-0.113; c.z=-0.05; c.w= 0.145;
	//	c.w=-0.456426; c.x=0.510553; c.y=0.122400; c.z= -0.092400;

	//	c.w=-0.2; c.x=0.4; c.y=-0.4; c.z= -0.4;
		c.w=-0.125; c.x=-0.256; c.y=0.847; c.z= 0.00895;


	for(int i=0; i<tx; i++)
		for(int j=0; j<ty; j++)
			for(int k=0; k<tz; k++){
				//q.x=px+i*mX; q.y=py+j*mY; q.z=pz+k*mZ; q.w=cst;
				q.w=px+(double)i*mX; 
				q.x=py+(double)j*mY; 
				q.y=pz+(double)k*mZ; 
				q.z=cst;

				c=q;

				cpt=0;
				do{

					/*tmp=q.square();
					q=(tmp+c);*/
					
					tmp=q;
					q.mult(tmp);
					q.mult(tmp);
					q.mult(tmp);
					q.add(c);

					norm=q.Norm();


					cpt++;
					
					//if(norm!=1.0)
						//printf("%f %d\n", norm, norm);
						//cout<<norm<<"!\n";

				}while(norm<2.0 && cpt<20);

				if(cpt>=20)
					dens[INDEX(i, j, k)]=norm/1.0f;//0.5f;
				else
					dens[INDEX(i, j, k)]=0.0f;

				/*l=q.Norm();
				if(l*l<4.0)
					dens[INDEX(i, j, k)]=0.5;
				else
					dens[INDEX(i, j, k)]=0.0;*/
				//printf("%d\n", cpt);
				//dens[INDEX(i, j, k)]=cpt/10.0;//((float)cpt/10.0f);
				//dens[INDEX(i, j, k)]=l;

			}

		

}